//
//  MakeArray.m
//
//  Created by Gallerand Sbastien on Tue Feb 17 2004.
//  Copyright (c) 2004 Gallerand Sbastien. All rights reserved.
//

#import "MakeArray.h"

// -------------------------------------------------------------------
// Implmentation de la classe MakeArray
// -------------------------------------------------------------------

@implementation MakeArray

/*
 Initialiseur par dfaut 
*/
- (id)init {
    return [self initWithString:@""];   
}

/*
 Initialiseur principal de la classe
*/
- (id)initWithString:(NSString *)chaine {
    if (self = [super init])
        [self setString:chaine];
    return self;
}

/*
 Dsallocation des instances d'objet
*/
- (void)dealloc {
    [_chaine release];
}

/*
 Accesseurs
*/
- (void)setString:(NSString *)chaine {
    [chaine retain];
    [_chaine release];
    _chaine = chaine;
}

/*
 Mthode de rsupration du tableau
*/
- (NSArray *)combinaisons {
    
    NSMutableArray *letters = [NSMutableArray array];
    int i;
    int n = [_chaine length];
    // Stackage des lettres du mot dans un tableau
    for (i=1;i<n;i++)
        [letters addObject:[_chaine stringFromIndex:i withLength:1]];
    // Initialisation du tableau des combinaisons avec la premire lettre
    NSMutableArray *result = [NSMutableArray arrayWithObjects:[_chaine stringFromIndex:0 withLength:1],nil];
    // Tant qu'il reste des lettres, on tend le tableau
    while ( [letters count] != 0 ) {
        [result expandArrayWithString:[letters objectAtIndex:0]];
        [letters removeObjectAtIndex:0];
    }
   
    return result;
}

@end

// -------------------------------------------------------------------
// Implmentation de la catgorie de NSMutableArray
// -------------------------------------------------------------------

@implementation NSMutableArray (NSArrayCat)

- (NSMutableArray *)expandArrayWithString:(NSString *)string {
   
    NSMutableString *newString;
    int index;
    int n = [self count];
    NSRange aSuppr = NSMakeRange(0,n);
    // Pour chaque NSString du tableau...
    for ( index = 0 ; index < n ; index++ ) {

        int j;
        int m = [(NSString *)[self objectAtIndex:index] length];
        // On intercale la lettre  chaque position dans le mot
        for ( j = 0 ; j <= m ; j++ ) {
            newString = [[NSMutableString alloc] initWithString:[self objectAtIndex:index]];
            [newString insertString:string atIndex:j];
            [self addObject:newString];
            [newString release];
        }
    }
    // On retire les mots provisoires
    [self removeObjectsInRange:aSuppr];
    
    return self;
}

@end

// -------------------------------------------------------------------
// Implmentation de la catgorie de NSString
// -------------------------------------------------------------------

@implementation NSString (NSStringCat)

- (NSString *)stringFromIndex:(int)start withLength:(int)length {
    
    if ([self length] < start+length)
        return nil;
    
    NSRange r = NSMakeRange(start,length);
    
    return [self substringWithRange:r];
}

@end